/*
* Copyright (c) 2023 - 2024 MINRES Technologies GmbH
*
* SPDX-License-Identifier: Apache-2.0
*
* Generated at 2024-02-19 14:24:37 UTC 
* by peakrdl_mnrs version 1.2.2
*/

#ifndef _BSP_APB3GPIO_H
#define _BSP_APB3GPIO_H

#include <stdint.h>

typedef struct __attribute((__packed__)) {
    volatile uint32_t VALUE;
    volatile uint32_t WRITE;
    volatile uint32_t WRITEENABLE;
}apb3gpio_t;

inline uint32_t get_gpio_value(volatile apb3gpio_t *reg){
    return (reg->VALUE >> 0) & 0xffffffff;
}
inline uint32_t get_gpio_write(volatile apb3gpio_t *reg){
    return (reg->WRITE >> 0) & 0xffffffff;
}
inline void set_gpio_write(volatile apb3gpio_t *reg, uint32_t value){
    reg->WRITE = (reg->WRITE & ~(0xffffffffU << 0)) | (value << 0);
}
inline uint32_t get_gpio_writeEnable(volatile apb3gpio_t *reg){
    return (reg->WRITEENABLE >> 0) & 0xffffffff;
}
inline void set_gpio_writeEnable(volatile apb3gpio_t *reg, uint32_t value){
    reg->WRITEENABLE = (reg->WRITEENABLE & ~(0xffffffffU << 0)) | (value << 0);
}
#endif /* _BSP_APB3GPIO_H */