/* See LICENSE of license details. */

#include <stdint.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#if defined(BOARD_ehrenberg)
#include "platform.h"
#endif
#include "platform.h"
#include "stub.h"
#include "weak_under_alias.h"

ssize_t __wrap_read(int fd, void* ptr, size_t len)
{
    uint8_t * current = (uint8_t *)ptr;
#if defined(BOARD_hifive1)
    volatile uint32_t * uart_rx = (uint32_t *)(UART0_CTRL_ADDR + UART_REG_RXFIFO);
    volatile uint8_t * uart_rx_cnt = (uint8_t *)(UART0_CTRL_ADDR + UART_REG_RXCTRL + 2);
#elif defined(BOARD_iss)
    volatile uint32_t * uart_rx = (uint32_t*)0xFFFF0000;
#elif defined(BOARD_TGCP)
    //TODO: implement
#elif !defined(BOARD_ehrenberg)
    volatile uint32_t * uart_rx = (uint32_t *)(UART0_BASE_ADDR + UART_REG_RXFIFO);
    volatile uint8_t * uart_rx_cnt = (uint8_t *)(UART0_BASE_ADDR + UART_REG_RXCTRL + 2);
#endif
    ssize_t result = 0;
    if (isatty(fd)) {
#if defined(BOARD_ehrenberg)
        for (current = (uint8_t *)ptr;
            (current < ((uint8_t *)ptr) + len) && (get_uart_rx_tx_reg_rx_avail(uart) > 0);
            current ++) {
          *current = uart_read(uart);
          result++;
        }
#elif defined(BOARD_iss)
    for (current = (uint8_t *)ptr;
                (current < ((uint8_t *)ptr) + len);
                current ++) {
            *current = *uart_rx;
            result++;
        }
#elif defined(BOARD_TGCP)
    //TODO: implement
#else
        for (current = (uint8_t *)ptr;
                (current < ((uint8_t *)ptr) + len) && (*uart_rx_cnt > 0);
                current ++) {
            *current = *uart_rx;
            result++;
        }
#endif
        return result;
    }
    return _stub(EBADF);
}
weak_under_alias(read);

